LruCacheClassPathRepository (Apache Commons BCEL 6.6.1 API)

org.apache.bcel.util

## Class LruCacheClassPathRepository

- java.lang.Object
- - org.apache.bcel.util.LruCacheClassPathRepository

- All Implemented Interfaces:
    Repository

      public class LruCacheClassPathRepository
      extends Object

  Maintains a least-recently-used (LRU) cache of `JavaClass` with maximum size `cacheSize`.

  This repository supports a class path consisting of too many JAR files to handle in `ClassPathRepository` or `MemorySensitiveClassPathRepository` without causing `OutOfMemoryError`.

  Since:
    6.4.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `LruCacheClassPathRepository(ClassPath path, int cacheSize)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `clear()` Clears all entries from cache.
    `JavaClass` | `findClass(String className)` Finds the class with the name provided, if the class isn't there, return NULL.
    `ClassPath` | `getClassPath()` Gets the ClassPath associated with this Repository
    `JavaClass` | `loadClass(Class<?> clazz)` Finds the JavaClass object for a runtime Class object.
    `JavaClass` | `loadClass(String className)` Finds a JavaClass object by name.
    `void` | `removeClass(JavaClass javaClass)` Removes class from repository
    `void` | `storeClass(JavaClass javaClass)` Stores the provided class under "clazz.getClassName()"

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### LruCacheClassPathRepository

          public LruCacheClassPathRepository(ClassPath path,
                                             int cacheSize)

  - ### Method Detail

    - #### clear

          public void clear()

      Description copied from interface: `Repository`
      Clears all entries from cache.
      Specified by:
        `clear` in interface `Repository`

    - #### findClass

          public JavaClass findClass(String className)

      Description copied from interface: `Repository`
      Finds the class with the name provided, if the class isn't there, return NULL.
      Specified by:
        `findClass` in interface `Repository`

    - #### removeClass

          public void removeClass(JavaClass javaClass)

      Description copied from interface: `Repository`
      Removes class from repository
      Specified by:
        `removeClass` in interface `Repository`

    - #### storeClass

          public void storeClass(JavaClass javaClass)

      Description copied from interface: `Repository`
      Stores the provided class under "clazz.getClassName()"
      Specified by:
        `storeClass` in interface `Repository`

    - #### getClassPath

          public ClassPath getClassPath()

      Description copied from interface: `Repository`
      Gets the ClassPath associated with this Repository
      Specified by:
        `getClassPath` in interface `Repository`

    - #### loadClass

          public JavaClass loadClass(Class<?> clazz)
                              throws ClassNotFoundException

      Finds the JavaClass object for a runtime Class object. If a class with the same name is already in this Repository, the Repository version is returned. Otherwise, getResourceAsStream() is called on the Class object to find the class's representation. If the representation is found, it is added to the Repository.
      Specified by:
        `loadClass` in interface `Repository`
      Parameters:
        `clazz` - the runtime Class object
      Returns:
        JavaClass object for given runtime class
      Throws:
        `ClassNotFoundException` - if the class is not in the Repository, and its representation could not be found
      See Also:
        `Class`

    - #### loadClass

          public JavaClass loadClass(String className)
                              throws ClassNotFoundException

      Finds a JavaClass object by name. If it is already in this Repository, the Repository version is returned. Otherwise, the Repository's classpath is searched for the class (and it is added to the Repository if found).
      Specified by:
        `loadClass` in interface `Repository`
      Parameters:
        `className` - the name of the class
      Returns:
        the JavaClass object
      Throws:
        `ClassNotFoundException` - if the class is not in the Repository, and could not be found on the classpath

Copyright © 2004–2022 The Apache Software Foundation. All rights reserved.